/*
 * MeasureTimeInterval.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "F28335/DSP28x_Project.h"

#ifndef DSP28335_TIMEINTERVAL_H_
#define DSP28335_TIMEINTERVAL_H_

namespace DSP28335
{

class MeasureTimeInterval
{
private:
    CPUTIMER_VARS& m_CPUTimer;
    Uint32 m_time_interval;
    Uint32 m_time_interval_previous;
    Uint32 m_magic_number;
public:
    MeasureTimeInterval(CPUTIMER_VARS& CPUTimer);
public:
    void    start(void);
    void    stop(void);
    Uint32  interval(void);
    void    reset(void);
    void    inc_counter();
    void    reset_counter();
    void    set_magic(const Uint32 magic);
    //
};//end class MeasureTimeStartStop

} /* namespace DSP28335 */

#endif /* DSP28335_TIMEINTERVAL_H_ */
